<script setup lang="ts">
defineProps({
  modelValue: Boolean,
  slideRight: Boolean,
});
defineEmits(["update:modelValue"]);
</script>

<template>
  <div>
    <Teleport to="body">
      <div id="modal-container" v-if="modelValue">
        <div
          id="backdrop"
          @click="$emit('update:modelValue', false)"
          class="fade-in"
        ></div>
        <section id="modal" :class="{ 'slide-in-from-right': slideRight }">
          <slot />
        </section>
      </div>
    </Teleport>
  </div>
</template>

<style scoped>
#modal-container {
  position: absolute;
  left: 0;
  top: 0;
  height: 100vh;
  width: 100vw;
}
#backdrop {
  position: absolute;
  left: 0;
  top: 0;
  height: 100vh;
  width: 100vw;
  background-color: var(--theme-backdrop-color);
  z-index: 1000;
}
#modal {
  z-index: 1001;
  background-color: var(--theme-background);
  border: 2px solid var(--theme-text-darker);
}
#modal.slide-in-from-right {
  position: absolute;
  top: var(--theme-sidebar-top);
  right: 0;
  width: 50vw;
  border-top-left-radius: 10px;
  border-bottom-left-radius: 10px;
  border-right: none;
}
</style>
